--- u-boot-1.1.6/include/cmd_confdefs.h	2006-11-02 09:15:01.000000000 -0500
+++ u-boot/include/cmd_confdefs.h	2007-05-23 15:02:04.000000000 -0400
@@ -167,6 +167,7 @@
 #define CONFIG_BOOTP_SEND_HOSTNAME	0x00000100
 #define CONFIG_BOOTP_NTPSERVER		0x00000200
 #define CONFIG_BOOTP_TIMEOFFSET		0x00000400
+#define CONFIG_BOOTP_SERVER		0x00000800
 
 #define CONFIG_BOOTP_VENDOREX		0x80000000
 
@@ -176,7 +177,8 @@
 #define CONFIG_BOOTP_DEFAULT		(CONFIG_BOOTP_SUBNETMASK | \
 					CONFIG_BOOTP_GATEWAY	 | \
 					CONFIG_BOOTP_HOSTNAME	 | \
-					CONFIG_BOOTP_BOOTPATH)
+					CONFIG_BOOTP_BOOTPATH	 | \
+					CONFIG_BOOTP_SERVER)
 
 #ifndef CONFIG_BOOTP_MASK
 #define CONFIG_BOOTP_MASK		CONFIG_BOOTP_DEFAULT
--- u-boot-1.1.6/net/bootp.c	2006-11-02 09:15:01.000000000 -0500
+++ u-boot/net/bootp.c	2007-05-21 11:43:15.000000000 -0400
@@ -120,10 +120,12 @@
 	IPaddr_t tmp_ip;
 
 	NetCopyIP(&NetOurIP, &bp->bp_yiaddr);
+#if (CONFIG_BOOTP_MASK & CONFIG_BOOTP_SERVER)
 	NetCopyIP(&tmp_ip, &bp->bp_siaddr);
 	if (tmp_ip != 0)
 		NetCopyIP(&NetServerIP, &bp->bp_siaddr);
 	memcpy (NetServerEther, ((Ethernet_t *)NetRxPkt)->et_src, 6);
+#endif
 	if (strlen(bp->bp_file) > 0)
 		copy_filename (BootFile, bp->bp_file, sizeof(BootFile));
 
